with mengen; use mengen;
with text_io; use text_io;

procedure MengenTester is

   A : Menge := LeerMengeAuf (5,15);
   B : Menge := LeerMengeAuf (5,15);
   C : Menge := LeerMengeAuf (-5,25);
   D : Menge := LeerMengeAuf (5,-15);

   procedure Teste (Text : String; 
                    Testling : Menge) is
   begin
      put (Text);
      put (" => ");
      drucke (Testling);      
      new_line (3);
   end Teste; 
   
begin

   Teste ("A", A);
   put_line ("IstLeer (A) => " & Boolean'image(IstLeer (A)));
   new_line (2);
   
   Eintragen ((11,6,9,7), A);
   Teste ("Eintragen ((11,6,9,7), A)", A);
   put_line ("IstLeer (A) => " & Boolean'image(IstLeer (A)));
   new_line (2);

   Teste ("B", B);
   Eintragen ((12,6,5,11), B);
   Teste ("Eintragen ((12,6,5,7), A)", B);
   
   Teste ("A+B", A+B);
   Teste ("A*B", A*B);
   
   put_line ("LiegtIn (5, A+B) => " & Boolean'image(LiegtIn (5, A+B)));
   new_line (2);
   put_line ("LiegtIn (5, A*B) => " & Boolean'image(LiegtIn (5, A*B)));
   new_line (2);
   put_line ("IstLeer (A*B) => " & Boolean'image(IstLeer (A*B)));
   new_line (2);
   
   Eintragen ((11,6,9,7,19,0,-5), C);
   Teste ("Eintragen ((11,6,9,7,19,0,-5), C)", C);
   
   declare
   begin
      drucke(A+C);
   exception
      when GrundMengenVerschieden => 
         put ("A+C => Ausnahme: GrundMengenVerschieden"); new_line (3);
      when others => 
         put ("A+C => unerwartete Ausnahme"); new_line (3);
   end; 
   
   declare
   begin
      drucke(C*B);
   exception
      when GrundMengenVerschieden => 
         put ("C*B => Ausnahme: GrundMengenVerschieden"); new_line (3);
      when others => 
         put ("C*B => unerwartete Ausnahme"); new_line (3);
   end; 
      
   Teste ("C+C", C+C);
   Teste ("C*C", C*C);

   declare
   begin -- robuster Aufruf
      Eintragen ((11,6,9,7), D);
   exception
      when others => put ("Erwartete Ausnahme bei Eintragen ((11,6,9,7), D)");
                     new_line(3);
   end;  
   
   put_line ("IstLeer (D) => " & Boolean'image(IstLeer (D))); new_line (2);

end MengenTester;
